<?php

namespace SGalinski\TypoScriptReferenceFrontend\Controller;

/*                                                                        *
 * This script belongs to the TYPO3 Flow package "SGalinski.TypoScriptReferenceFrontend".*
 *                                                                        *
 *                                                                        */

use SGalinski\TypoScriptReferenceFrontend\Service\TsrefRestService;
use TYPO3\Flow\Annotations as Flow;

class TsrefController extends \TYPO3\Flow\Mvc\Controller\ActionController {
	/**
	 * @var TsrefRestService
	 */
	protected $tsrefRestService;

	/**
	 * The constructor is used for dependency injection.
	 *
	 * @param TsrefRestService $service
	 */
	public function __construct(TsrefRestService $service) {
		$this->tsrefRestService = $service;
	}

	/**
	 * The action which fetches the data for typoScript reference page, and displays the page.
	 *
	 * @param int $typeId
	 * @param null $superTypeId
	 * @return void
	 */
	public function indexAction($typeId = NULL, $superTypeId = NULL) {
		$attributes = $this->tsrefRestService->getTypes();

		if ($typeId !== NULL) {
			//TODO: fetch all data for attribute with id: $typeId
			$properties = $this->tsrefRestService->getPropertiesByParentId($typeId);
			$this->view->assign('properties', $properties);
		}
		if ($superTypeId !== NULL) {
			//TODO: fetch all data for attribute with id: $typeId
			$superType = $this->tsrefRestService->getAttributeById($superTypeId);
			$this->view->assign('superType', $superType);
		}

		$this->view->assign('types', $attributes);
		$this->view->assign('typeId', $typeId);
	}
}